Chuyển đến nội dung
Diễn đàn CADViet
  • Thông báo

    • Nguyen Hoanh

      CADViet đã hoàn tất nâng cấp   14/09/2017

      Chào các bạn, CADViet đã hoàn tất việc nâng cấp lên phiên bản mới. Tất cả các chức năng đã hoạt động theo kỳ vọng của ban quản trị. Nếu có vấn đề gì cần phản hồi, các bản post ở đây nhé: Trân trọng, Nguyễn Hoành.
Đăng nhập để thực hiện theo  
toanmda

Chỉ giúp tôi cách lấy dữ liệu từ Dialog vào Lisp

Các bài được khuyến nghị

Mình là lính mới tò te nên không biết gì, mọi người đừng cười nhé. Nhờ anh em trên Cadviet viết cho mình đoạn lisp lấy thông số nhập vào từ hộp thoại như sau:

Cadviet.bmp

- File cadviet.dcl

Line: dialog {
label = "Cadviet";
:boxed_column {
label = "Toa do A";
: edit_box { label = "Xa"; edit_width = 6; key = "Xa"; }
: edit_box { label = "Ya"; edit_width = 6; key = "Ya"; }
}
:boxed_column {
label = "Toa do B";
: edit_box { label = "Xb"; edit_width = 6; key = "Xb"; }
: edit_box { label = "Yb"; edit_width = 6; key = "Yb"; }
}
ok_cancel_err;
}

Và lisp sẽ vẽ ra một đoạn thẳng AB có toạ độ như đã nhập ở hộp thoại.

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Mình là lính mới tò te nên không biết gì, mọi người đừng cười nhé. Nhờ anh em trên Cadviet viết cho mình đoạn lisp lấy thông số nhập vào từ hộp thoại như sau:

........

Và lisp sẽ vẽ ra một đoạn thẳng AB có toạ độ như đã nhập ở hộp thoại.

 

Bạn dùng thử LISP này nhé.

Chú ý : LISP chưa kiểm tra tính hợp lệ của dữ liệu người dùng nhập vào, nếu nhập giá trị không phải là số thì sẽ bi lỗi.

Ex: "123ab", "15 00", ...

Nhớ các cao thủ bổ sung dùm.

(defun c:DrawLine (/ id status Pa Pb)
 (setq id (load_dialog "cadviet.dcl"))
 (if (not (new_dialog "Line" id))
   (progn (unload_dialog id) (exit))
 )
 (SetDataDefault)
 (action_tile "accept" "(GetData)(done_dialog 3)")
 (setq status (start_dialog))
 (if (= status 3)
   (progn      
     (draw_line)
     (unload_dialog id)
     (princ)
   )
 )

)

(defun SetDataDefault()
 (set_tile "Xa" "0") (set_tile "Ya" "500")
 (set_tile "Xb" "1000") (set_tile "Yb" "1500")  
 )

(defun GetData(/ xa ya xb yb)
 (setq xa (atof (get_tile "Xa"))
ya (atof (get_tile "Ya"))
xb (atof (get_tile "Xb"))
yb (atof (get_tile "Yb"))
Pa (list xa ya)
Pb (list xb yb) )
)

(defun draw_line()  
 (command "line" Pa Pb "")
 (command "zoom" Pa Pb )
)

 

File cadviet.dcl của bạn.

Line: dialog {
label = "Cadviet";
:boxed_column {
label = "Toa do A";
: edit_box { label = "Xa"; edit_width = 6; key = "Xa"; }
: edit_box { label = "Ya"; edit_width = 6; key = "Ya"; }
}
:boxed_column {
label = "Toa do B";
: edit_box { label = "Xb"; edit_width = 6; key = "Xb"; }
: edit_box { label = "Yb"; edit_width = 6; key = "Yb"; }
}
ok_cancel_err;
}

  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Tạo một tài khoản hoặc đăng nhập để nhận xét

Bạn cần phải là một thành viên để lại một bình luận

Tạo tài khoản

Đăng ký một tài khoản mới trong cộng đồng của chúng tôi. Điều đó dễ mà.

Đăng ký tài khoản mới

Đăng nhập

Bạn có sẵn sàng để tạo một tài khoản ? Đăng nhập tại đây.

Đăng nhập ngay

Đăng nhập để thực hiện theo  

×